Recognise Ed25519 in X509_certificate_type
[openssl.git] / config
diff --git a/config b/config
index 1d33126b9e8c26576c8ff727dbb3b9ff91a76994..c8886de4310797e10b19c0162b0ecdee64920e54 100755 (executable)
--- a/config
+++ b/config
@@ -1,5 +1,5 @@
 #!/bin/sh
-# Copyright 1998-2016 The OpenSSL Project Authors. All Rights Reserved.
+# Copyright 1998-2017 The OpenSSL Project Authors. All Rights Reserved.
 #
 # Licensed under the OpenSSL license (the "License").  You may not use
 # this file except in compliance with the License.  You can obtain a copy
@@ -11,7 +11,8 @@
 #
 # Do "config -h" for usage information.
 SUFFIX=""
-TEST="false"
+DRYRUN="false"
+VERBOSE="false"
 EXE=""
 THERE=`dirname $0`
 
@@ -20,11 +21,13 @@ for i
 do
 case "$i" in 
 -d*) options=$options" --debug";;
--t*) TEST="true";;
--h*) TEST="true"; cat <<EOF
+-t*) DRYRUN="true" VERBOSE="true";;
+-v*) VERBOSE="true";;
+-h*) DRYRUN="true"; cat <<EOF
 Usage: config [options]
  -d    Build with debugging when possible.
  -t    Test mode, do not run the Configure perl script.
+ -v    Verbose mode, show the exact Configure call that is being made.
  -h    This help.
 
 Any other text will be passed to the Configure perl script.
@@ -184,6 +187,10 @@ case "${SYSTEM}:${RELEASE}:${VERSION}:${MACHINE}" in
         echo "${MACH}-${ARCH}-freebsd${VERS}"; exit 0
         ;;
 
+    DragonFly:*)
+       echo "${MACHINE}-whatever-dragonfly"; exit 0
+       ;;
+
     FreeBSD:*)
        echo "${MACHINE}-whatever-freebsd"; exit 0
        ;;
@@ -313,6 +320,15 @@ case "${SYSTEM}:${RELEASE}:${VERSION}:${MACHINE}" in
        echo "${MACHINE}-v11-${SYSTEM}"; exit 0;
        ;;
 
+    # The following combinations are supported
+    # MINGW64* on x86_64 => mingw64
+    # MINGW32* on x86_64 => mingw
+    # MINGW32* on i?86 => mingw
+    #
+    # MINGW64* on i?86 isn't expected to work...
+    MINGW64*:*:*:x86_64)
+       echo "${MACHINE}-whatever-mingw64"; exit 0;
+       ;;
     MINGW*)
        echo "${MACHINE}-whatever-mingw"; exit 0;
        ;;
@@ -450,7 +466,7 @@ case "$GUESSOS" in
   mips4-sgi-irix64)
        echo "WARNING! If you wish to build 64-bit library, then you have to"
        echo "         invoke '$THERE/Configure irix64-mips4-$CC' *manually*."
-       if [ "$TEST" = "false" -a -t 1 ]; then
+       if [ "$DRYRUN" = "false" -a -t 1 ]; then
          echo "         You have about 5 seconds to press Ctrl-C to abort."
          (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
        fi
@@ -469,7 +485,7 @@ case "$GUESSOS" in
        if [ "$ISA64" = "1" -a -z "$KERNEL_BITS" ]; then
            echo "WARNING! If you wish to build 64-bit library, then you have to"
            echo "         invoke '$THERE/Configure darwin64-ppc-cc' *manually*."
-           if [ "$TEST" = "false" -a -t 1 ]; then
+           if [ "$DRYRUN" = "false" -a -t 1 ]; then
              echo "         You have about 5 seconds to press Ctrl-C to abort."
              (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
            fi
@@ -484,7 +500,7 @@ case "$GUESSOS" in
        if [ "$ISA64" = "1" -a -z "$KERNEL_BITS" ]; then
            echo "WARNING! If you wish to build 64-bit library, then you have to"
            echo "         invoke 'KERNEL_BITS=64 $THERE/config $options'."
-           if [ "$TEST" = "false" -a -t 1 ]; then
+           if [ "$DRYRUN" = "false" -a -t 1 ]; then
              echo "         You have about 5 seconds to press Ctrl-C to abort."
              # The stty technique used elsewhere doesn't work on
              # MacOS. At least, right now on this Mac.
@@ -497,16 +513,6 @@ case "$GUESSOS" in
            OUT="darwin-i386-cc"
        fi ;;
   x86_64-apple-darwin*)
-       if [ -z "$KERNEL_BITS" ]; then
-           echo "WARNING! If you wish to build 32-bit library, then you have to"
-           echo "         invoke 'KERNEL_BITS=32 $THERE/config $options'."
-           if [ "$TEST" = "false" -a -t 1 ]; then
-             echo "         You have about 5 seconds to press Ctrl-C to abort."
-             # The stty technique used elsewhere doesn't work on
-             # MacOS. At least, right now on this Mac.
-             sleep 5
-           fi
-       fi
        if [ "$KERNEL_BITS" = "32" ]; then
            OUT="darwin-i386-cc"
        else
@@ -538,7 +544,7 @@ case "$GUESSOS" in
        if [ -z "$KERNEL_BITS" ]; then
            echo "WARNING! If you wish to build 64-bit library, then you have to"
            echo "         invoke '$THERE/Configure linux-ppc64' *manually*."
-           if [ "$TEST" = "false" -a -t 1 ]; then
+           if [ "$DRYRUN" = "false" -a -t 1 ]; then
                echo "         You have about 5 seconds to press Ctrl-C to abort."
                (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
            fi
@@ -555,7 +561,7 @@ case "$GUESSOS" in
   mips64*-*-linux2)
        echo "WARNING! If you wish to build 64-bit library, then you have to"
        echo "         invoke '$THERE/Configure linux64-mips64' *manually*."
-       if [ "$TEST" = "false" -a -t 1 ]; then
+       if [ "$DRYRUN" = "false" -a -t 1 ]; then
            echo "         You have about 5 seconds to press Ctrl-C to abort."
            (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
        fi
@@ -572,7 +578,7 @@ case "$GUESSOS" in
        echo "WARNING! If you *know* that your GNU C supports 64-bit/V9 ABI"
        echo "         and wish to build 64-bit library, then you have to"
        echo "         invoke '$THERE/Configure linux64-sparcv9' *manually*."
-       if [ "$TEST" = "false" -a -t 1 ]; then
+       if [ "$DRYRUN" = "false" -a -t 1 ]; then
          echo "          You have about 5 seconds to press Ctrl-C to abort."
          (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
        fi
@@ -620,7 +626,7 @@ case "$GUESSOS" in
        #if egrep -e '^features.* highgprs' /proc/cpuinfo >/dev/null ; then
        #  echo "WARNING! If you wish to build \"highgprs\" 32-bit library, then you"
        #  echo "         have to invoke './Configure linux32-s390x' *manually*."
-       #  if [ "$TEST" = "false" -a -t -1 ]; then
+       #  if [ "$DRYRUN" = "false" -a -t -1 ]; then
        #    echo "         You have about 5 seconds to press Ctrl-C to abort."
        #    (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
        #  fi
@@ -633,7 +639,14 @@ case "$GUESSOS" in
        else
            OUT="linux-x86_64"
        fi ;;
-  *86-*-linux2) OUT="linux-elf" ;;
+  *86-*-linux2)
+        # On machines where the compiler understands -m32, prefer a
+        # config target that uses it
+        if $CC -m32 -E -x c /dev/null > /dev/null 2>&1; then
+            OUT="linux-x86"
+        else
+            OUT="linux-elf"
+        fi ;;
   *86-*-linux1) OUT="linux-aout" ;;
   *-*-linux?) OUT="linux-generic32" ;;
   sun4[uv]*-*-solaris2)
@@ -643,7 +656,7 @@ case "$GUESSOS" in
            if [ "$CC" = "cc" -a $CCVER -ge 50 ]; then
                echo "WARNING! If you wish to build 64-bit library, then you have to"
                echo "         invoke '$THERE/Configure solaris64-sparcv9-cc' *manually*."
-               if [ "$TEST" = "false" -a -t 1 ]; then
+               if [ "$DRYRUN" = "false" -a -t 1 ]; then
                  echo "         You have about 5 seconds to press Ctrl-C to abort."
                  (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
                fi
@@ -655,7 +668,7 @@ case "$GUESSOS" in
                OUT="solaris64-sparcv9-gcc"
                echo "WARNING! If you wish to build 32-bit library, then you have to"
                echo "         invoke '$THERE/Configure solaris-sparcv9-gcc' *manually*."
-               if [ "$TEST" = "false" -a -t 1 ]; then
+               if [ "$DRYRUN" = "false" -a -t 1 ]; then
                  echo "         You have about 5 seconds to press Ctrl-C to abort."
                  (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
                fi
@@ -663,7 +676,7 @@ case "$GUESSOS" in
                echo "NOTICE! If you *know* that your GNU C supports 64-bit/V9 ABI"
                echo "        and wish to build 64-bit library, then you have to"
                echo "        invoke '$THERE/Configure solaris64-sparcv9-gcc' *manually*."
-               if [ "$TEST" = "false" -a -t 1 ]; then
+               if [ "$DRYRUN" = "false" -a -t 1 ]; then
                  echo "         You have about 5 seconds to press Ctrl-C to abort."
                  (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
                fi
@@ -694,6 +707,7 @@ case "$GUESSOS" in
   powerpc64-*-*bsd*)   OUT="BSD-generic64"; options="$options -DB_ENDIAN" ;;
   sparc64-*-*bsd*)     OUT="BSD-sparc64" ;;
   ia64-*-*bsd*)                OUT="BSD-ia64" ;;
+  x86_64-*-dragonfly*)  OUT="BSD-x86_64" ;;
   amd64-*-*bsd*)       OUT="BSD-x86_64" ;;
   *86*-*-*bsd*)                # mimic ld behaviour when it's looking for libc...
                        if [ -L /usr/lib/libc.so ]; then        # [Free|Net]BSD
@@ -747,7 +761,7 @@ case "$GUESSOS" in
             if [ $KERNEL_BITS -eq 64 -a "$CC" = "cc" ]; then
                echo "WARNING! If you wish to build 64-bit library then you have to"
                echo "         invoke '$THERE/Configure hpux64-parisc2-cc' *manually*."
-               if [ "$TEST" = "false" -a -t 1 ]; then
+               if [ "$DRYRUN" = "false" -a -t 1 ]; then
                  echo "         You have about 5 seconds to press Ctrl-C to abort."
                  (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
                fi
@@ -784,7 +798,7 @@ case "$GUESSOS" in
            if [ $KERNEL_BITS -eq 64 ]; then
                echo "WARNING! If you wish to build 64-bit kit, then you have to"
                echo "         invoke '$THERE/Configure aix64-cc' *manually*."
-               if [ "$TEST" = "false" -a -t 1 ]; then
+               if [ "$DRYRUN" = "false" -a -t 1 ]; then
                    echo "         You have ~5 seconds to press Ctrl-C to abort."
                    (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
                fi
@@ -850,7 +864,7 @@ case "$GUESSOS" in
   i386-*) options="$options 386" ;;
 esac
 
-for i in aes bf camellia cast des dh dsa ec hmac idea md2 md5 mdc2 rc2 rc4 rc5 ripemd rsa seed sha
+for i in aes aria bf camellia cast des dh dsa ec hmac idea md2 md5 mdc2 rc2 rc4 rc5 ripemd rsa seed sha
 do
   if [ ! -d $THERE/crypto/$i ]
   then
@@ -900,14 +914,19 @@ OUT="$OUT"
 
 $PERL $THERE/Configure LIST | grep "$OUT" > /dev/null
 if [ $? = "0" ]; then
-  echo Configuring for $OUT
-
-  if [ "$TEST" = "true" ]; then
+  if [ "$VERBOSE" = "true" ]; then
     echo $PERL $THERE/Configure $OUT $options
-  else
+  fi  
+  if [ "$DRYRUN" = "false" ]; then
     $PERL $THERE/Configure $OUT $options
   fi
 else
   echo "This system ($OUT) is not supported. See file INSTALL for details."
+  exit 1
+fi
+
+if [ "$OUT" = "darwin64-x86_64-cc" ]; then
+    echo "WARNING! If you wish to build 32-bit libraries, then you have to"
+    echo "         invoke 'KERNEL_BITS=32 $THERE/config $options'."
 fi
 )